#!/usr/bin/perl

use strict;
use warnings;
#use CGI::Util qw(escape unescape);

#システム変数をまとめたハッシュ。
our %system;
#CGIの名前を取得。
$system{ 'cgi' }      = &this();
#キャプチャ画像の基盤保存ディレクトリ名。
$system{ 'log' }      = 'log';
#ログの保存日数。
$system{ 'logs' }     = 10;
#サムネイルの基本数。
$system{ 'thumbnum' } = 40;
#カメラの最大数。
$system{ 'max' }       = 1;

#GET形式でデータを取得。
our %GET = &DecodeGET( 'out', 'day', 'num', 'pic', 'dev', 'cap' );
&Format();

#ヘッダの出力。
print "Content-type: text/html\n\n";
print &main();

sub main()
{
  my $html;

  if( $GET{ 'out' } eq 'list' )
  {
    #リスト形式で取得。
    #配列で返されたものを,区切りで結合。
    $html = join( ',', &GetList( $GET{ 'day' }, $system{ 'thumbnum' } ) );
  }elsif( $GET{ 'out' } eq 'last' )
  {
    #最新の情報を返す。
    $html = &GetList( -1, 1 );
  }elsif( $GET{ 'out' } eq 'past' )
  {
    #過去へのリンクを返す。
    $html .= &HtmlHeader();
    $html .= &HtmlPastList();
    $html .= &HtmlFooter();
  }else
  {
#    if( $GET{ 'day' } < 0){$GET{ 'day' } = 0;}
    if( $GET{ 'cap' } eq '1' )
    {
      `./capture.sh`;
    }
    #一覧を返す。
    $html .= &HtmlHeader();
    $html .= &HtmlMain();
    $html .= &HtmlFooter();
  }

  return $html;
}

sub HtmlMain()
{
  my $html = '';
  my @list;
  if( $GET{ 'day' } >= 0 )
  {
    @list = &GetList( $GET{ 'day' }, 0 );
  }else
  {
    @list = &GetList( $GET{ 'day' }, $system{ 'thumbnum' } );
  }
  #画像ファイルが存在しない。
  unless( -f $GET{ 'pic' } )
  {
    $GET{ 'pic' } = $list[0];
  }
  $GET{ 'pic' } =~ s/thumb/pic/;
  if( -f $GET{ 'pic' } )
  {
    $GET{ 'pic' } = sprintf('<a href="%s" target="_blank"><img src="%s" /></a>', $GET{ 'pic' }, $GET{ 'pic' } );
  }else
  {
    $GET{ 'pic' } = sprintf('%s', 'No Image' );
  }
  $html .= sprintf( '<div class="viewmain" id="mainview">%s</div>', $GET{ 'pic' } );

  if( $GET{ 'day' } == -1 )
  {
    $html .= sprintf( '<div class="button">%s', "\n" );
    $html .= sprintf( ' <form action="%s" method="GET" style="margin:0px;">%s', $system{ 'cgi' }, "\n" );
    $html .= sprintf( '  <input type="submit" value="撮影" />%s', "\n" );
    $html .= sprintf( ' </form>%s', "\n" );
    $html .= sprintf( '</div>%s', "\n" );
  }

  $html .= sprintf( '<div class="viewlist" id="list">%s', "\n" );

  foreach( @list )
  {
    $html .= sprintf( ' <div class="viewitem"><a href="%s?day=%d&pic=%s"><img src="%s" /></a></div>%s',
                      $system{ 'cgi' }, $GET{ 'day' }, $_, $_, "\n" );
  }
  $html .= sprintf( '</div>%s', "\n" );

  $html .= sprintf( '<div class="linkbar">%s', "\n" );
#  $html .= sprintf( ' <span><a href="./webcam.cgi?day=0">もっと見る</a></span>%s', "\n" );
  $html .= sprintf( ' <span><a href="./webcam.cgi?out=past">過去へ</a></span>%s', "\n" );
  $html .= sprintf( '</div>%s', "\n" );

  return $html;
}

sub HtmlPastList()
{
  my $html = '<div class="linklist">'."\n";

  #ディレクトリ名を作る。
  my $dir = $system{ 'log' };

  #ディレクトリが存在するか。
  if( -d $dir )
  {
    my @filelist = &Sort( '>', &GetFileList( 'directory', $dir ) );
    my $n;
    my $max = $system{ 'logs' };
    if( $max > scalar( @filelist ) )
    {
      $max = scalar( @filelist );
    }
    for( $n = 0 ; $n < $max ; ++$n )
    {
      $filelist[$n] =~ /([\d]{4})([\d]{2})([\d]{2})/;
      my ( $year, $month, $day ) = ( $1, $2 , $3 );
      $html .= sprintf( '<div class="link"><a href="./webcam.cgi?day=%d">%d日前</a> - %d年%d月%d日</div>%s',
                       $n, $n,
                       $year, $month, $day, "\n" );
    }
  }

  $html .= '</div>'."\n";
  return $html;
}

sub HtmlHeader()
{
  return sprintf('<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN">
<html lang="ja">
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
  <meta http-equiv="Content-Style-Type" content="text/css">
  <meta name="author" content="Hiroki">
  <link rel="stylesheet" href="./style.css" type="text/css">
  <link rel="Shortcut Icon" href="./icon.ico">
  <title>New WebCam System</title>
</head>
<body>

<div class="header">
 <div class="pagename"><a href="./index.html"><img src="./icon.png" />New WebCam System</a></div>
 <div class="menu">
  <span><a href="./webcam.cgi?day=-1">純HTML版</a></span>
  <span><a href="./webcam.cgi?out=past">過去ログ</a></span>
 </div>
</div>

<div class="logo"><a href="./index.html"><img src="./logo.png" /></a></div>
'
  );
}

sub HtmlFooter()
{
  return sprintf('
<div class="footer">Made by Hiroki</div>

</body>
</html>
'
  );
}

#画像一覧を取得する。
sub GetList()
{
  my ( $day, $num ) = @_;
  my @filelist;

  if( $day ne '' && $day >= 0 )
  {
    $day = &day2dir( $day );
    #ディレクトリ名を作る。
    my $dir = &PathJoin( '/', $system{ 'log' }, $day, 'thumb' );
    #ディレクトリが存在するか。
    if( -d $dir )
    {
      @filelist = &Sort( '>', &GetFileList( 'file', $dir ) );
      #取得数が0より大きいならその数に合わせる。
      if( $num > 0 )
      {
        #配列の数が取得数より大きい間要素を削除する。
        while( scalar( @filelist ) > $num )
        {
          pop( @filelist );
        }#end while
      }#end num

      foreach( @filelist )
      {
        $_ = &PathJoin( '/', $dir, $_ );
      }
    }#end if dir
  }else
  {
    #最新から規定量を得るまでリストを作る。
    #logディレクトリ内のディレクトリを取得。
    foreach( &Sort( '>', &GetFileList( 'directory', $system{ 'log' } ) ) )
    {
      my $dir = &PathJoin( '/', $system{ 'log' }, $_, 'thumb' );
      if( -d $dir )
      {
        my @temp = &Sort( '>', &GetFileList( 'file', &PathJoin( '/', $dir ) ) );
        foreach( @temp )
        {
          if( scalar( @filelist ) < $num )
          {
            push( @filelist, &PathJoin( '/', $dir, $_ ) );
          }
        }#end if temp
        if( scalar( @filelist ) > $num )
        {
          last;
        }
      }#end if dir
    }#end foreach dir
  }

  return @filelist;
}

#受け取ったデータを整形する。
sub Format()
{
  if( $GET{ 'day' } eq '' )
  {
    $GET{ 'day' } = -1;
  }

  if( $GET{ 'num' } eq '' || $GET{ 'num' } =~ /[\D]/ )
  {
    #空白か数字でないものが含まれているならサムネイルの基本の数にする。
    $GET{'num'} = $system{ 'thumbnum' };
  }

  if( $GET{ 'dev' } eq '' )
  {
    $GET{ 'dev' } = 0;
  }
  $system{ 'log' } .= '_' . $GET{ 'dev' } . '/';

}

sub day2dir( $ )
{
  my ( $day ) = @_;
  if( 0<= $day && $day < $system{ 'logs' } )
  {
    #n日前の情報を知りたいかどうかを調べる。
    my @list = &Sort( '>', &GetFileList( 'directory', $system{ 'log' } ) );
    if( $day + 1 < scalar( @list ) )
    {
      #n日前を具体的な日にちにする。
      $day = $list[$day];
    }else
    {
      #最も古いものを返す。
      $day = pop( @list );
    }
  }
  return $day;
}

#CGIの名前を返す。
sub this
{
  #環境変数からCGIの名前を取得し、/で分割する。
  my( @name ) = split( /\//, $ENV{"SCRIPT_NAME"} );
  #最後の値を返す。
  return pop( @name );
}

#ファイルパスを結合する。
sub PathJoin()
{
  my $div=shift(@_);
  my $ret=join($div,@_);
  $ret=~s/$div{2,}/$div/g;
  while($ret=~s/$div[\w\+%\$\.;:\&=\?!\*~\@\(\)\.]+$div\.\.$div/$div/){}
  while($ret=~s/$div\.$div/$div/){}
  return $ret;
}

#ディレクトリを開く。
sub OpenDirectory
{
  my( $address ) = @_;

  #ディレクトリが存在するかどうか調べる。
  if(-d $address )
  {
    #ディレクトリを開く。
    if( opendir( DIR, $address ) )
    {
      #開けたので一覧を読み込んで返す。
      my @return = readdir( DIR );
      closedir(DIR);
      return @return;
    }
  }
  return '';
}

#ファイルを開いて任意の一覧を返す。
sub GetFileList
{
  my( $type, $address ) = @_;
  my( @return );
  #ディレクトリを開く。
  my @directory = &OpenDirectory( $address );

  #要素があれば処理を行う。
  if( @directory )
  {
    if( $type =~ /(file)/i || $type eq '4' )
    {
      #$typeが4かfileならばファイルだけ返す。
      foreach( @directory )
      {
        #ファイル名を作ってみる。
        my( $filename ) = join( "/", $address, $_ );
        #ファイルとして存在するならば配列に追加する。
        if( -f $filename ){ push( @return, $_ ); }
      }
    }elsif( $type =~ /(directory)/i || $type eq '3' )
    {
      #$typeが3かdirectoryならばディレクトリだけ返す。
      foreach( @directory )
      {
        #ディレクトリ名を作ってみる。
        my( $dirname ) = join( "/", $address, $_ );
        #ディレクトリとして存在し、.か..でなければ配列に追加する。
        if( -d $dirname && $_ ne "." && $_ ne ".." )
        {
          push( @return, $_ );
        }
      }
    }elsif( $type =~ /(alldirectory)/i ||  $type eq '2' )
    {
      #$typeが2かalldirectoryならばディレクトリ全てを返す。
      foreach(@directory)
      {
        #ディレクトリ名を作ってみる。
        my( $dirname ) = join( "/", $address, $_ );
        #ディレクトリとして存在するなら配列に追加する。
        if( -d $dirname )
        {
          push( @return, $_ );
        }
      }
    }elsif( $type =~ /(filedirectory|directoryfile)/i || $type eq '1' )
    {
      #$typeが1かfileとdhirectoryの組み合わせならばファイルかディレクトリ全てを返す。
      foreach( @directory )
      {
        #.か..でなければ配列に追加する。
        if( $_ ne "." && $_ ne ".." )
        {
          push( @return, $_ );
        }
      }
    }else
    {
      #全てを返す。
      @return = @directory;
    }
  }else
  {
    #全てを返す。
    @return = @directory;
  }

  return @return;
}

#ファイルを開く。
sub OpenFile
{
  my( $file ) = @_;

  #ファイルを開く。
  if( open( READ, "<$file" ) )
  {
    my @ret = <READ>;
    close( READ );
    return @ret;
  }
  #ファイルがなければ空白を返す。
  return '';
}

#ソートする。
sub Sort
{
  my( $type, @array ) = @_;

  if( $type eq "<" )
  {
    #昇順でソート。
    @array = &SortAscending( @array );
  }elsif( $type eq ">" )
  {
    #降順でソート。
    @array = &SortDescending( @array );
  }

  return @array;
}

#昇順ソート。
sub SortAscending
{
  return sort{ $a <=> $b }( @_ );
}

#降順ソート。
sub SortDescending
{
  return sort{ $b <=> $a }( @_ );
}

#GET形式のデータを取得。
sub DecodeGET
{
  my( @names ) = @_;
  my( %ret );
  #GETデータを取得。
  my $query = $ENV{'QUERY_STRING'};

  #&で分割。
  my @args = split( /&/, $query );
  foreach(@args)
  {
    #=でデータを2つに分割。
    my( $name, $val ) = split( /=/, $_, 2 );
    #値の+をスペースに変換。
    $val =~ tr/+/ /;
    #%[16進数2桁]を見つけたら16進数を受け取ってpackする。
    $val =~ s/%([0-9a-fA-F][0-9a-fA-F])/pack('C', hex($1))/eg;
    unless( exists( $ret{ $name } ) )
    {
      #ハッシュに存在しないならば値を代入して作る。
      $ret{$name}=$val;
    }else
    {
      #ハッシュが存在するので配列にする。

      unless( ref( $ret{ $name } ) eq 'ARRAY' )
      {
        #配列ではない。
        #値を保存。
        my $tmp = $ret{ $name };
        #ハッシュを一度削除する。
        delete( $ret{ $name } );
        #無名配列にする。
        $ret{ $name }[ 0 ] = $tmp;
      }
      #無名配列に値を追加。
      push( @{ $ret{ $name } }, $val );
    }
  }

  #必要なハッシュが存在しない場合は初期化。
  foreach( @names )
  {
    unless( exists( $ret{ $_ } ) )
    {
      $ret{ $_ } = '';
    }
  }

  return %ret;
}


